diff -ruN freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.c freeswan-1.9/klips/net/ipsec/ipsec_radij.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.c	Sun Nov  5 23:32:08 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_radij.c	Wed May 16 10:57:20 2001
@@ -13,7 +13,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_radij.c,v 1.41 2000/11/06 04:32:08 rgb Exp $
+ * RCSID $Id: ipsec_radij.c,v 1.44 2001/05/03 19:41:01 rgb Exp $
  */
 
 #include <linux/config.h>
@@ -90,7 +90,7 @@
 int
 ipsec_cleareroutes(void)
 {
-	int error;
+	int error = 0;
 
 	spin_lock_bh(&eroute_lock);
 
@@ -105,15 +105,17 @@
 ipsec_breakroute(struct sockaddr_encap *eaddr, struct sockaddr_encap *emask)
 {
 	struct radij_node *rn;
-	int error;
+	int error = 0;
 #ifdef CONFIG_IPSEC_DEBUG
 	char buf1[64], buf2[64];
 	
 	if (debug_eroute) {
 		subnettoa(eaddr->sen_ip_src, emask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(eaddr->sen_ip_dst, emask->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_breakroute: attempting to delete eroute for %s->%s\n",
-			       buf1, buf2);
+		printk("klips_debug:ipsec_breakroute: "
+		       "attempting to delete eroute for %s->%s\n",
+		       buf1,
+		       buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
@@ -141,7 +143,7 @@
 ipsec_makeroute(struct sockaddr_encap *eaddr, struct sockaddr_encap *emask, struct sa_id said)
 {
 	struct eroute *retrt;
-	int error;
+	int error = 0;
 	char sa[SATOA_BUF];
 	size_t sa_len;
 #ifdef CONFIG_IPSEC_DEBUG
@@ -151,14 +153,18 @@
 		subnettoa(eaddr->sen_ip_src, emask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(eaddr->sen_ip_dst, emask->sen_ip_dst, 0, buf2, sizeof(buf2));
 		sa_len = satoa(said, 0, sa, SATOA_BUF);
-		printk("klips_debug:ipsec_makeroute: attempting to insert eroute for %s->%s, SA: %s\n",
-		       buf1, buf2, sa);
+		printk("klips_debug:ipsec_makeroute: "
+		       "attempting to insert eroute for %s->%s, SA: %s\n",
+		       buf1,
+		       buf2,
+		       sa_len ? sa : " (error)");
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
 	retrt = (struct eroute *)kmalloc(sizeof (struct eroute), GFP_ATOMIC);
 	if (retrt == NULL) {
-		printk("klips_error:ipsec_makeroute: not able to allocate kernel memory");
+		printk("klips_error:ipsec_makeroute: "
+		       "not able to allocate kernel memory");
 		return ENOMEM;
 	}
 	memset((caddr_t)retrt, 0, sizeof (struct eroute));
@@ -177,12 +183,15 @@
 	
 	if(error) {
 		sa_len = satoa(said, 0, sa, SATOA_BUF);
-		printk("klips_debug:ipsec_makeroute: rj_addroute not able to insert eroute for SA:%s\n", sa);
+		printk("klips_debug:ipsec_makeroute: "
+		       "rj_addroute not able to insert eroute for SA:%s\n",
+		       sa_len ? sa : " (error)");
 		kfree(retrt); /* XXX -- should we? */
 		return error;
 	}
 	KLIPS_PRINT(debug_eroute,
-		    "klips_debug:ipsec_makeroute: succeeded, I think...\n");
+		    "klips_debug:ipsec_makeroute: "
+		    "succeeded, I think...\n");
 	return 0;
 }
 
@@ -196,11 +205,21 @@
 	if (debug_radij & DB_RJ_FINDROUTE) {
 		addrtoa(eaddr->sen_ip_src, 0, buf1, sizeof(buf1));
 		addrtoa(eaddr->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_findroute: %s->%s\n",
-		       buf1, buf2);
+		printk("klips_debug:ipsec_findroute: "
+		       "%s->%s\n",
+		       buf1,
+		       buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 	rn = rj_match((caddr_t)eaddr, rnh);
+	if(rn) {
+		KLIPS_PRINT(debug_eroute,
+			    "klips_debug:ipsec_findroute: "
+			    "found, points to proto=%d, spi=%x, dst=%x.\n",
+			    ((struct eroute*)rn)->er_said.proto,
+			    ntohl(((struct eroute*)rn)->er_said.spi),
+			    ntohl(((struct eroute*)rn)->er_said.dst.s_addr));
+	}
 	return (struct eroute *)rn;
 }
 		
@@ -217,8 +236,10 @@
 	struct sockaddr_encap *key, *mask;
 	
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:ipsec_rj_walker_procprint: rn=%p, w0=%p\n",
-		    rn, w0);
+		    "klips_debug:ipsec_rj_walker_procprint: "
+		    "rn=%p, w0=%p\n",
+		    rn,
+		    w0);
 	if (rn == NULL)	{
 		return 120;
 	}
@@ -239,7 +260,9 @@
 	sa_len = satoa(ro->er_said, 0, sa, SATOA_BUF);
 	w->len += sprintf(w->buffer + w->len,
 			  "%-18s -> %-18s => %s\n",
-			  buf1, buf2, sa);
+			  buf1,
+			  buf2,
+			  sa_len ? sa : " (error)");
 	
 	w->pos = w->begin + w->len;
 	if(w->pos < w->offset) {
@@ -258,7 +281,7 @@
 {
 	struct rjtentry *rd = (struct rjtentry *)rn;
 	struct radij_node *rn2;
-	int error;
+	int error = 0;
 	struct sockaddr_encap *key, *mask;
 #ifdef CONFIG_IPSEC_DEBUG
 	char buf1[64] = { 0 }, buf2[64] = { 0 };
@@ -272,14 +295,16 @@
 	mask = rd_mask(rd);
 	
 	if(!key || !mask) {
-		return -1;
+		return -ENODATA;
 	}
 #ifdef CONFIG_IPSEC_DEBUG
 	if(debug_radij)	{
 		subnettoa(key->sen_ip_src, mask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(key->sen_ip_dst, mask->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_rj_walker_delete: deleting: %s -> %s\n",
-		       buf1, buf2);
+		printk("klips_debug:ipsec_rj_walker_delete: "
+		       "deleting: %s -> %s\n",
+		       buf1,
+		       buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
@@ -291,8 +316,8 @@
 	}
 
 	if(rn2 != rn) {
-		printk("klips_debug:ipsec_rj_walker_delete: tried to delete a different node?!?"
-		       "This should never happen!\n");
+		printk("klips_debug:ipsec_rj_walker_delete: "
+		       "tried to delete a different node?!?  This should never happen!\n");
 	}
 	memset((caddr_t)rn, 0, sizeof (struct eroute));
 	kfree(rn);
@@ -302,6 +327,17 @@
 
 /*
  * $Log: ipsec_radij.c,v $
+ * Revision 1.44  2001/05/03 19:41:01  rgb
+ * Initialise error return variable.
+ * Use more appropriate return value for ipsec_rj_walker_delete().
+ *
+ * Revision 1.43  2001/02/27 22:24:54  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.42  2001/02/27 06:21:57  rgb
+ * Added findroute success instrumentation.
+ *
  * Revision 1.41  2000/11/06 04:32:08  rgb
  * Ditched spin_lock_irqsave in favour of spin_lock_bh.
  *
